/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */


#include "pKio.h"
// #include <jni.h>

#include "classReferences.h"
#include "common_type.h"
#include "string_type.h"
#include "SUPERVISEUR_types.h"
typedef void* typeDCG;

// Must be after SUPERVISEUR_types.h
#include "opersignal.h"
#include "const_i.h"
#include "const_gra_i.h"

#include "graphicalTypes.h"
#include "typ_acces.h"
#include "sysfile_type.h"
#include "buffer_type.h"

#include "string_api.h"
#include "tree_api.h"
#include "ident_g.h"

#include "sysfile_g.h"
#include "sysfileRepfil_g.h"
#include "signal_tree.h"
#include "biblio_g.h"
#include "systemFrontEnd_g.h"

#include "GHDC_type.h"
#include "kernel_type.h"
#include "OptionManager.h"
#include "BatchCompiler.h"
#include "supervis.h"
#include "builder.h"
#include "currentObjectsManager.h"
#include "graphicalTrees.h"
#include "SUPERVISEUR_body.h"
#include "interfSignalC_g.h"

#include "LiaisonSignal.h"
#include "LiaisonSignalC2Java_g.h"
#include "LiaisonSignal_m.c"
#include "LiaisonSignalC2Java_g.c"
#include "LiaisonSignal_g.c"
