/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
#include "boolean.h"
#include <string.h>
#include "C_string.h"
#include "ansi.h"
#include "OS_host.h"
#include "stringStd_g.h"
#include "stringmemStr_type.h"
#include "stringmemStr_g.h"
#include "stringmemRegister_type.h"
#include "stringmemRegister_g.h"
#include "stringmemPhy_type.h"
#include "stringmemPhy_g.h"
#include "tree_type.h"
#include "ident_type.h"
#include "intetreesGetSet_g.h"
#include "sysfile_type.h"
/* ======0=========0=========0 system API for environment handling
 */
#include "systemFrontEnd_g.h"
#include "sysfile_graphical_g.h"

#include "graphicalTypes.h"
#include "LiaisonSignalC2Java_g.h"

#include "sysfile_g.h"
#include "sysfileRepfil_g.h"
#include "sysfile_m.c"
#include "sysfile_g.c"
#include "sysfileRepfil_g.c"
#include "sysfile_graphical_g.c"
