process SUPERVISEUR =
     ( ? event HE;
     )
   pragmas 
      Comment "Signal GUI controller"
      Note "Creation d' un module et déplacement des communs avec GUI"
           "APPUI_BOUTON vers InteSignalGUI"
   end pragmas
   (| (| MENUS{}
       | MEMORISE{}
%        ( ? boolean END_NON_REMANENT; 
            action_type REMANENT; 
            action_type NON_REMANENT; 
            mouse_type MOUSE_BUTTON;
          ! action_type ON; 
            event START_REMANENT; 
            event START_ACTION;
%
       | MOUSE{}
       | VEILLE{} %!ON_ACTION%
%        ( ? event START_ACTION; 
            action_type ASSOCIATE_PORT; 
            boolean INHIBIT; 
            action_type ON; 
            mouse_type MOUSE_BUTTON; 
            event START_REMANENT;
          ! event FIRST_CLICK; 
            action_type ON_ACTION; 
            integer X; 
            integer Y;
        )
% 
       | CANVAS{}
       | FEED_BACK{}
       |)/ END_NON_REMANENT, END_VALIDATE_PORTS, endNonRem, INHIBIT, Y, X, FIRST_CLICK, ON_ACTION, MOUSE_BUTTON, START_ACTION, START_REMANENT, ON, ASSOCIATE_PORT, NON_REMANENT, REMANENT |)
   where 
   use InteSignalCompiler; 
   use InteSignalGUI; 
   use InteObjectSignalGUI; 
   boolean successfulAction;
   action TRACE =
        ( ? string message; action_type ON_ACTION;
           )
      pragmas
        C_Code "TRACE((char*) &i1, &i2)"
        CPP_Code "TRACE((char*)&i1, &i2)"
     end pragmas
      
      ; 
   process MENUS =
        ( ? event HE;
          ! action_type REMANENT; 
            action_type NON_REMANENT; 
            action_type ASSOCIATE_PORT;
            boolean successfulAction;
        )
      pragmas 
         Comment "Mouse click detection in menu areas"
                 "to be changed"
      end pragmas
      (| (| (| he := HE
             | (| cAction := GetMenuButton()
                | currentAction := cAction when (cAction/=#C_no_action)
                | cAction ^= he
                |)/ cAction
             |) where event he; end
          | successfulAction := FILE_ACTION(currentAction)
          | EDIT_ACTION(currentAction)
          | VIEW_ACTION(currentAction)
          | OTHER_ACTION(currentAction)
          | (| DRAW := currentAction when ((currentAction=#C_move) or (currentAction=#C_resize) or (currentAction=#C_justif))
             | EDIT := currentAction when ((currentAction=#C_creer) or (currentAction=#C_cut_graph)  or (currentAction=#C_paste_graph) or (currentAction=#C_encaps) or (currentAction=#C_decaps) or (currentAction=#C_copy_Icon) or (currentAction=#C_link_map))
             | REMANENT := (currentAction when (currentAction=#C_embed)) default (currentAction when (currentAction=#C_nop)) default EDIT default DRAW default (currentAction when ((currentAction=#C_halo) or (currentAction=#C_selection))) |)/ EDIT, DRAW
          | (| NON_REMANENT := (ASSOCIATE_PORT when (ASSOCIATE_PORT=#C_cliqportnom)) default (currentAction when ((currentAction=#C_copy_graph) or (currentAction=#C_bte_map))) |)
          | TOOLS_ACTION(currentAction)
          | (| AssPort := CONFIRM(currentAction)
             | ASSOCIATE_PORT := AssPort
             |) where action_type AssPort; end
          |)/ currentAction |)
      where 
      process FILE_ACTION =
           ( ? action_type currentAction;
             ! boolean successfulAction;
           )
         pragmas 
            Comment "Atomic interactions with file system"
         end pragmas
         (| successfulLoading := LOAD_ACTION(currentAction)
          | SAVE_ACTION(currentAction)
          | (| PostScript :: PostscriptPrint()
             | PostScript ^= true when (currentAction=#C_save_PS)
             |)
          | displayConfirm(J_raz when (currentAction=#C_raz))
          | (| Quit :: quitApplication()
             | Quit ^= true when (currentAction=#C_the_end)
             |)
	  | successfulAction := successfulLoading
          |)
         where 
         label Quit, PostScript; 
         boolean successfulLoading;
         process LOAD_ACTION =
              ( ? action_type currentAction;
	        ! boolean successfulLoading;
              )
            (| successfulLoading := loadFile(J_load when (currentAction=#C_load), true) 
                            default loadFile(J_parse when (currentAction=#C_parse), false)
                            default loadFile(J_load_Lib when (currentAction=#C_load_Lib), true)
             |)
         ; 
         process SAVE_ACTION =
              ( ? action_type currentAction;
              )
            (| saveFile(J_saveAllRoots when (currentAction=#C_saveAllRoots), true)
             | saveFile(J_saveAllRootsAs when (currentAction=#C_saveAllRootsAs), true)
             | saveFile(J_saveAs when (currentAction=#C_saveAs), true)
             | saveFile(J_unparseAs when (currentAction=#C_unparseAs), false)
             | saveFile(J_save when (currentAction=#C_save), true)
             |)
            where 
            label h;
            end
         ;
         end
      ; 
      process EDIT_ACTION =
           ( ? action_type currentAction;
           )
         (| (| currentModel := getCurrentModel()
             | changeModelCat(currentModel, currentAction when ((currentAction=#C_ch_typ_func) or (currentAction=#C_ch_typ_proc) or (currentAction=#C_ch_typ_act) or (currentAction=#C_ch_typ_node)))
             |)/ currentModel
          | (| Etiq :: END_MAPPING()
             | Etiq ^= true when (currentAction=#C_end_map)
             |)
          | (| Etiq1 ^= true when (currentAction=#C_replaceIdent) ^= currentModel
             | Etiq1 :: currentModel := getCurrentModel()
             | (ident1, ident2) := RECUP_IDENTS()
             | REPLACING_IDENT(currentModel, ident1, ident2)
             |)/ currentModel
          |)
         where 
         ptident ident1, ident2; 
         label Etiq, Etiq1; 
         process RECUP_IDENTS =
              ( ! ptident ident1; 
                  ptident ident2;
              )
              spec (| ident1 ^= ident2 |)
         
         ; 
         process REPLACING_IDENT =
              ( ? ntrees t; 
                  ptident ident1; 
                  ptident ident2;
              )
              spec (| t ^= ident1 ^= ident2 |)
         
         ; 
         ntrees currentModel;
         end
      ; 
      process VIEW_ACTION =
           ( ? action_type currentAction;
           )
         (| DETAILS(currentAction)
          | (| SEL := currentAction when (currentAction=#C_selection)
             | Etiq :: razSelectBuf()
             | Etiq ^= SEL
             |)/ SEL
          | NAMES(currentAction)
          | DISPLAYING_POLICE(currentAction when (currentAction=#C_box_police))
          | DISPLAYING_POLICE(currentAction when (currentAction=#C_port_police))
          |)
         where 
         label Etiq; 
         process DETAILS =
              ( ? action_type currentAction;
              )
            (| (| DISPLAYING_DETAILS(showDetails)
                | (| showDetails := getDetailState()
                   | showDetails ^= true when (currentAction=#C_displayDetails)
                   |)
                |)/ showDetails |)
            where 
            boolean showDetails;
            end
         ; 
         process NAMES =
              ( ? action_type currentAction;
              )
            (| (| DISPLAYING_NAMES(showNames)
                | (| showNames := getNamesState()
                   | showNames ^= true when (currentAction=#C_displayPortNames)
                   |)
                |)/ showNames |)
            where 
            boolean showNames;
            end
         ; 
         action_type SEL;
         end
      ; 
      process TOOLS_ACTION =
           ( ? action_type currentAction;
           )
         (| PROVE_ACTION(currentAction)
          | COMPILE(currentAction)
          |)
         where 
         process PROVE_ACTION =
              ( ? action_type currentAction;
              )
            (| (| CallEtiq :: CALLING_PROVER()
                | CallEtiq ^= true when (currentAction=#C_call_prov)
                |)
             | (| BuildEtiq :: BUILDING_RESOLV()
                | BuildEtiq ^= true when (currentAction=#C_incl_prov)
                |)
             |)
            where 
            label CallEtiq, BuildEtiq;
            end
         ; 
         process COMPILE =
              ( ? action_type currentAction;
              )
            (| (| AUTO_INTER_COMPILING(tree when (not isArchi))
                | ARCHI_COMPILING(tree when isArchi)
                | (| tree := getCurrentModel()
                   | isArchi := (true when (currentAction=#C_archi_compil)) default (false when ((currentAction=#C_inter_comp) or (currentAction=#C_auto_comp)))
                   | tree ^= isArchi
                   |)
                |)/ isArchi, tree |)
            where 
            process INIT_COMPILE =
                 ( ? ntrees t; 
                     boolean fini; 
                     boolean not_ok;
                   ! ntrees tree_init;
                 )
               (| (| zprem := prem$1 init true
                   | prem := not_ok default fini default (false when (^zprem))
                   | tree_init := t when zprem
                   | prem ^= t
                   |)/ prem, zprem |)
            ; 
            process AUTO_INTER_COMPILING =
                 ( ? ntrees tree;
                 )
               (| (| (| (AUTO, DIRECT) := GET_COMPILING_MOD(igraph when (not err))
                      | END_COMP_ERR([:err])
                      |)
                   %  | (| H::TRACE("AUTO_INTER_COMPILING ERR" when err, action_type#C_nop) | H ^= [:err] |) where label H; end
                      | (| H::TRACE("AUTO_INTER_COMPILING NOT ERR " when not err, action_type#C_nop) | H ^= [:not err] |) where label H; end%
                   | (igraph, err) := TREE2GRAPH(tree, ^tree, fini)
                   | (| (| S := s
                         | (| (| interactive := (not AUTO) cell S
                               | WIN_DISPLAY([/:AUTO])
                               | init_state := #basicDCG when (not AUTO)
                               | ALLOWED_FUNC_DISPLAY(init_state)
                               |)
                            | fini_inter := INTER_COMPILING(S, igraph when interactive)
                            |)
                         |)/ init_state, interactive |) where event S; end
                   | (| fini1 := AUTO_COMPILING(igraph when AUTO when (not DIRECT))
                      | fini2 := DIRECT_COMPILING(igraph when AUTO when DIRECT)
                      | fini_auto := fini1 default fini2
                      |)
                   | fini := fini_auto default fini_inter default err
                   | s := ^tree
                   |)/ s, fini, fini_auto, fini_inter, err, igraph, DIRECT, AUTO |)
               where 
               boolean fini, fini_inter, ok, err, DIRECT, AUTO, fini1, fini_auto, fini_interfini1, fini2, interactive; 
               process AUTO_COMPILING =
                    ( ? typeDCG igraph;
                      ! boolean b;
                    )
                  (| AUTO_COMPILING_ACTIONS(igraph) |)
                  where 
                  process AUTO_COMPILING_ACTIONS =
                       ( ? typeDCG g;
                         ! boolean b;
                       )
                       spec (| g ^= b |)
                  
                  ;
                  end
               ; 
               process GET_COMPILING_MOD =
                    ( ? typeDCG t;
                      ! boolean B1; 
                        boolean B2;
                    )
                    spec (| t ^= B1 ^= B2 |)
               
               ; 
               process END_COMPILE =
                    ( ? boolean err_pre; 
                        boolean err_build; 
                        boolean err_func; 
                        function_type func;
                      ! boolean fini;
                    )
                  (| b := [:err_pre] default [:err_build] default [:err_func]
                   | fini := [:func=#func_end] default b
                   | END_COMP([:func=#func_end])
                   | END_COMP_ERR(b)
                   |)
                  where 
                  boolean b;
                  end
               ; 
               process TREE2GRAPH =
                    ( ? ntrees t; 
                        event S; 
                        boolean fini;
                      ! typeDCG igraph; 
                        boolean err;
                    )
                  (| (| INIT_COMPILE{}
                      | (| tree := tree_init
                         | PRE_COMPILE(tree, 1)
                         |) where ntrees tree; end/ h_ok
                      | GRAPH_BUILDING(tree_comp)
	              %  | (| H::TRACE("TREE2GRAPH err_pre" when err_pre, action_type#C_nop) | H ^= [:err_pre] |) where label H; end
	                 | (| H::TRACE("TREE2GRAPH err_build" when err_build, action_type#C_nop) | H ^= [:err_build] |) where label H; end  %
                      | err := [:err_pre] default err_build
                      |)/ err_build, err_pre, tree_comp, not_ok, tree_init |)
                  where 
                  ntrees tree_init, tree_comp; 
                  boolean not_ok, err_pre, err_build; 
                  event h_ok;
                  end
               ; 
               process GET_END_AUTO =
                    ( ! boolean fini_auto;
                    )
               
               ; 
               process ALLOWED_FUNC_DISPLAY =
                    ( ? DCGLevel state;
                    )
               
               ; 
               process WIN_DISPLAY =
                    ( ? event h_display;
                    )
               
               ; 
               process END_COMP_ERR =
                    ( ? boolean B;
                    )
               
               ; 
               process DIRECT_COMPILING =
                    ( ? typeDCG g;
                      ! boolean b;
                    )
                    spec (| g ^= b |)
               
               ; 
               process INTER_COMPILING =
                    ( ? event S; 
                        typeDCG gbasic;
                      ! boolean fini;
                    )
                  (| (| (| FUNCT_AUTOMATA{} |)/ err_func
                      | END_COMPILE{}
                      | (| vDCG ::= gbasic
                         | state ::= #basicDCG when (^gbasic)
                         | SEPARATE ::= false when (^gbasic)
                         |)
                      |)/ func |)
                  where 
                  statevar typeDCG vDCG init NILDCG; 
                  statevar boolean SEPARATE init false; 
                  statevar DCGLevel state init #undefDCG; 
                  process FUNCT_AUTOMATA =
                       ( ? event S;
                         ! function_type func; 
                           boolean err_func;
                       )
                     (| func := GET_FUNCTIONALITY(S)
                      | err_func := ACTIONS(func)
                      |)
                     where 
                     process GET_FUNCTIONALITY =
                          ( ? event S;
                            ! function_type func;
                          )
                        (| (funct, ok) := GET_FUNC()
                         | func := funct when ok
                         | ok ^= S
                         |)
                        where 
                        boolean ok; 
                        function_type funct; 
                        process GET_FUNC =
                             ( ! function_type funct; 
                                 boolean ok;
                             )
                             spec (| funct ^= ok |)
                        
                        ;
                        end
                     ; 
                     process ACTIONS =
                          ( ? function_type func;
                            ! boolean err;
                          )
                        (| (| (| END_OF_FUNCTIONALITY(ok)
                               | ok := ok1 default ok2 default ok3
                               | err := not ok
                               |)
                            | ok1 := InterFormats{}(func)
                            | ok2 := Transfos{}(func)
                            | ok3 := Generators{}(func)
                            |)/ ok3, ok2, ok1 |)
                        where 
                        boolean ok, ok1, ok2, ok3; 
                        process InterFormats =
                             ( ? func;
                               ! boolean ok;
                             )
                           (| (| (| Basic2Poly{}
                                  | ok_1 := ok
                                  |) where boolean ok; end
                               | (| Endo2Bool{}
                                  | ok_2 := ok
                                  |) where boolean ok; end
                               | (| Bool2Seq{}
                                  | ok_3 := ok
                                  |) where boolean ok; end
                               | (| Bool2Flat{}
                                  | ok_4 := ok
                                  |) where boolean ok; end
                               | (| ok5 := ok_5
                                  | ok4 := ok_4
                                  | ok3 := ok_3
                                  | ok2 := ok_2
                                  | ok1 := ok_1
                                  | ok := ok1 default ok5 default ok2 default ok3 default ok4
                                  |) where boolean ok1, ok2, ok3, ok4, ok5; end
                               | Selector{}
                               | (| Poly2Endo{}
                                  | ok_5 := ok
                                  |) where boolean ok; end
                               |)/ ok_5, b2s, b2f, e2b, p2e, b2p, ok_4, ok_3, ok_2, ok_1 |)
                           where 
                           process Basic2Poly =
                                ( ? event b2p;
                                  ! boolean ok;
                                )
                              (| (| (| x := #polyDCG when ok
                                     | state ::= x
                                     | vDCG ::= gpoly when ok
                                     | ALLOWED_FUNC_DISPLAY(x)
                                     |)
                                  | (ok, gpoly) := DCGBasic2DCGPoly((vDCG?) when b2p)
                                  |)/ gpoly |)
                              where 
                              event b; 
                              typeDCG gpoly; 
                              DCGLevel x;
                              end
                           ; 
                           process Endo2Bool =
                                ( ? event e2b;
                                  ! boolean ok;
                                )
                              (| (| (ok, gbool) := DCGEndo2DCGBool((vDCG?) when e2b)
                                  | (| state ::= x
                                     | x := #boolDCG when ok
                                     | vDCG ::= gbool when ok
                                     | ALLOWED_FUNC_DISPLAY(x)
                                     |)/ x
                                  |)/ gbool |)
                              where 
                              event b; 
                              typeDCG gbool; 
                              DCGLevel x;
                              end
                           ; 
                           process Bool2Flat =
                                ( ? event b2f;
                                  ! boolean ok;
                                )
                              (| (| (ok, gflat) := DCGBool2DCGFlat((vDCG?) when b2f)
                                  | (| state ::= x
                                     | x := #flatDCG when ok
                                     | vDCG ::= gflat when ok
                                     | ALLOWED_FUNC_DISPLAY(x)
                                     |)/ x
                                  |)/ gflat |)
                              where 
                              event b; 
                              typeDCG gflat; 
                              DCGLevel x;
                              end
                           ; 
                           process Bool2Seq =
                                ( ? event b2s;
                                  ! boolean ok;
                                )
                              (| (| (ok, gseq) := DCGBool2DCGSeq((vDCG?) when b2s)
                                  | (| state ::= x
                                     | x := #seqDCG when ok
                                     | vDCG ::= gseq when ok
                                     | ALLOWED_FUNC_DISPLAY(x)
                                     |)/ x
                                  |)/ gseq |)
                              where 
                              event b; 
                              typeDCG gseq; 
                              DCGLevel x;
                              end
                           ; 
                           process Selector =
                                ( ? func;
                                  ! e2b; 
                                    p2e; 
                                    event b2p; 
                                    event b2f; 
                                    event b2s;
                                )
                              (| b2p := [:(state?)=#basicDCG] when (func=#func_clockCalculus)
                               | p2e := [:(state?)=#polyDCG] when (func=#func_poly2endo)
                               | e2b := [:(state?)=#endoDCG] when (func=#func_booleanizing)
                               | b2f := [:(state?)=#boolDCG] when (func=#func_flattening)
                               | b2s := [:(state?)=#boolDCG] when (func=#func_serializing)
                               |)
                           ; 
                           process Poly2Endo =
                                ( ? event p2e;
                                  ! boolean ok;
                                )
                              (| (| (ok, gendo) := DCGPoly2DCGEndo((vDCG?) when p2e)
                                  | (| state ::= x
                                     | x := #endoDCG when ok
                                     | vDCG ::= gendo when ok
                                     | ALLOWED_FUNC_DISPLAY(x)
                                     |)/ x
                                  |)/ gendo |)
                              where 
                              event b; 
                              typeDCG gbool; 
                              gendo; 
                              DCGLevel x;
                              end
                           ; 
                           boolean ok_1, ok_2, ok_3, ok_4, ok_5; 
                           event b2p, p2e, e2b, b2f, b2s;
                           end
                        ; 
                        process Transfos =
                             ( ? function_type func;
                               ! boolean ok;
                             )
                           (| (| getLevel{}
                               | ok := ok1 default ok2 default ok3 default ok4 default ok5
                               | (| sel := cretiming
                                  | ok1 := Retiming((vDCG?) when sel, vlevel when sel)
                                  |) where event sel; end
                               | Selector{}
                               | (| sel := cBuildAbstraction
                                  | (| (ok3, gbool) := BuildAbstraction((vDCG?) when sel, vlevel when sel)
                                     | SEPARATE ::= true when sel
                                     | state ::= x
                                     | x := #boolDCG when ok3
                                     | vDCG ::= gbool when ok3
                                     | ALLOWED_FUNC_DISPLAY(x)
                                     |)
                                  |) where event sel; end/ gbool
                                             / x
                               | (| sel := cbooleans2events
                                  | ok2 := BooleansEvents((vDCG?) when sel, vlevel when sel)
                                  |) where event sel; end
                               | (| sel := cunify
                                  | ok5 := Unifications((vDCG?) when sel, vlevel when sel)
                                  |) where event sel; end
                               | (| sel := ctrainsCalculus
                                  | ok4 := trainsCalculus((vDCG?) when sel, vlevel when sel)
                                  |) where event sel; end
                               |)/ ok4, ok5, ok2, ok3, cBuildAbstraction, ctrainsCalculus, cunify, cbooleans2events, cretiming, ok1, vlevel |)
                           where 
                           boolean ok1, ok2, ok3, ok4, ok5; 
                           process Selector =
                                ( ? func;
                                  ! event cretiming; 
                                    event cbooleans2events; 
                                    event cunify; 
                                    event ctrainsCalculus; 
                                    event cBuildAbstraction;
                                )
                              (| cretiming := [:func=#func_retiming]
                               | cbooleans2events := [:func=#func_booleans2events]
                               | cunify := [:func=#func_unify]
                               | ctrainsCalculus := [:func=#func_trains]
                               | cBuildAbstraction := [:func=#func_abstraction]
                               |)
                           ; 
                           vlevel; 
                           event cretiming, cbooleans2events, cunify, ctrainsCalculus, cBuildAbstraction; 
                           typeDCG gbool; 
                           DCGLevel x;
                           end
                        ; 
                        process Generators =
                             ( ? function_type func;
                               ! boolean ok;
                             )
                           (| (| Selector{}
                               | (| sel := cGenZ3z
                                  | ok7 := GenZ3z((vDCG?) when sel, vlevel when sel)
                                  | ok7_1 := ok7
                                  |) where event sel; 
                                           ok7; end
                               | getLevel{}
                               | (| ok7 := ok6_7
                                  | ok6 := ok5_6
                                  | ok2 := ok8_5
                                  | ok5 := ok4_4
                                  | ok4 := ok3_3
                                  | ok3 := ok2_2
                                  | ok8 := ok7_1
                                  | ok := ok1 default ok2 default ok3 default ok4 default ok5 default ok6 default ok7 default ok8 default ok9
                                  |) where boolean ok8, ok3, ok4, ok5, ok2, ok6, ok7; end
                               | (| sel := cGenSignal
                                  | ok1 := GenSignal((vDCG?) when sel, vlevel when sel)
                                  |) where event sel; end
                               | (| sel := cGenC
                                  | ok2 := GenC((vDCG?) when sel, vlevel when sel)
                                  | ok2_2 := ok2
                                  |) where event sel; 
                                           ok2; end
                               | (| sel := cGenCseparate
                                  | ok3 := GenCseparate((vDCG?) when sel, vlevel when sel)
                                  | ok3_3 := ok3
                                  |) where event sel; 
                                           ok3; end
                               | (| sel := cGenCPP
                                  | ok4 := GenCPP((vDCG?) when sel, vlevel when sel)
                                  | ok4_4 := ok4
                                  |) where event sel; 
                                           ok4; end
                               | (| sel := cGenSignalAbs
                                  | ok8 := GenSignalAbs((vDCG?) when sel, vlevel when sel)
                                  | ok8_5 := ok8
                                  |) where event sel; 
                                           ok8; end
                               | (| sel := cGenJAVA
                                  | ok5 := GenJAVA((vDCG?) when sel, vlevel when sel)
                                  | ok5_6 := ok5
                                  |) where event sel; 
                                           ok5; end
                               | (| sel := cGenSyndexCode
                                  | ok6 := GenSyndexCode((vDCG?) when sel, vlevel when sel)
                                  | ok6_7 := ok6
                                  |) where event sel; 
                                           ok6; end
                               | (| sel := cmkProfiling
                                  | ok9 := mkProfiling((vDCG?) when sel, vlevel when sel)
                                  |) where event sel; end
                               |)/ ok9, ok6_7, ok5_6, ok8_5, ok4_4, ok3_3, ok2_2, ok1, vlevel, ok7_1, cmkProfiling, cGenZ3z, cGenSyndexCode, cGenJAVA, cGenCPP, cGenCseparate, cGenC, cGenSignalAbs, cGenSignal |)
                           where 
                           boolean ok1, ok2, ok3, ok4, ok5, ok6, ok7, ok8, ok9, ok7_1, ok2_2, ok3_3, ok4_4, ok8_5, ok5_6, ok6_7; 
                           DCGLevel vlevel; 
                           process Selector =
                                ( ? func;
                                  ! cGenSignal; 
                                    cGenSignalAbs; 
                                    cGenC; 
                                    cGenCseparate; 
                                    cGenCPP; 
                                    cGenJAVA; 
                                    cGenSyndexCode; 
                                    cGenZ3z; 
                                    cmkProfiling;
                                )
                              (| cGenSignal := [:func=#func_gen_SIGNAL]
                               | cGenSignalAbs := [:func=#func_gen_abstract]
                               | cGenC := [:(func=#func_gen_CANSI) and (not (SEPARATE?))]
                               | cGenCseparate := [:(func=#func_gen_CANSI) and (SEPARATE?)]
                               | cGenCPP := [:func=#func_gen_CPP]
                               | cGenJAVA := [:func=#func_gen_JAVA]
                               | cGenSyndexCode := [:func=#func_gen_Syndex]
                               | cGenZ3z := [:func=#func_gen_Z3Z]
                               | cmkProfiling := [:func=#func_profiling]
                               |)
                           ; 
                           event cGenSignal, cGenSignalAbs, cGenC, cGenCseparate, cGenCPP, cGenJAVA, cGenSyndexCode, cGenZ3z, cmkProfiling;
                           end
                        ; 
                        process getLevel =
                             ( ? func;
                               ! vlevel;
                             )
                           (| vlevel := (state?) when (^func) |)
                        ;
                        end
                     ;
                     end
                  ; 
                  process END_COMPILE =
                       ( ? function_type func;
                         ! boolean fini;
                       )
                     (| fini := [:func=#func_end]
                      | END_COMP([:fini])
                      |)
                     where 
                     boolean b;
                     end
                  ; 
                  function_type func; 
                  boolean err_func;
                  end
               ; 
               typeDCG igraph; 
               DCGLevel init_state; 
               event s;
               end
            ; 
            process ARCHI_COMPILING =
                 ( ? ntrees tree;
                 )
               pragmas 
                  Comment "Etrange, surement a modifier"
               end pragmas
               (| (| GRAPH_BUILDING(tree_comp)
                   | (| (gbool, err_func) := FUNCT_AUTOMATA(igraph)
                      | END_COMP_ARCHI(gbool when (^err_func), #boolDCG)
                      |)
                   | (| fini := [:err_pre] default [:err_build] default (^err_func)
                      | END_COMP_ERR_ARCHI([:err_pre] default [:err_build] default [:err_func])
                      |)/ fini
                   | (| PRE_COMPILE(tree, 3) |)/ not_ok
                                             / h_ok
                   |)/ tree_comp, err_pre, err_func, err_build, igraph |)
               where 
               typeDCG gbool, igraph; 
               process FUNCT_AUTOMATA =
                    ( ? typeDCG igraph;
                      ! typeDCG gbool; 
                        boolean err_func;
                    )
                  (| (| (ok0, gpoly) := DCGBasic2DCGPoly(igraph)
                      | (| b := ClockEnvBuilding(gpoly when ok1, #polyDCG)
                         | ok2 := InterfaceCalculus(gpoly when b, #polyDCG)
                         |)
                      | (ok3, gbool) := DCGPoly2DCGBool(gpoly when ok2)
                      | err_func := false when ok3
                      | (| gPoly := gpoly
                         | ok1 := transitiveClosure(gpoly when ok0, #polyDCG)
                         |) where typeDCG gPoly; end
                      |)/ ok1, ok3, ok2, gpoly, ok0 |)
                  where 
                  integer gr, s1, s2; 
                  typeDCG gpoly; 
                  boolean b, ok0, ok2, ok3, ok1;
                  end
               ; 
               boolean err_build, err_func, fini, not_ok, err_pre; 
               event h_ok; 
               ntrees tree_comp;
               end
            ; 
            process PRE_COMPILE =
                 ( ? ntrees tree; 
                     integer typ_comp;
                   ! ntrees tree_comp; 
                     event h_ok; 
                     boolean err_pre; 
                     boolean not_ok;
                 )
               (| (| (tree_c, err, ok) := PRE_COMP(tree, typ_comp)
                   | not_ok := [/:ok]
                   | err_pre := err when ok
                   | h_ok := [/:err_pre]
                   | tree_comp := tree_c when h_ok
                   |)/ tree_c, ok, err |)
               where 
               boolean ok, err; 
               ntrees tree_c;
               end
            ; 
            ntrees tree; 
            boolean isArchi;
            end
         ;
         end
      ; 
      process OTHER_ACTION =
           ( ? action_type currentAction;
           )
         (| (| UndoEtiq :: UNDOING()
             | UndoEtiq ^= true when (currentAction=#C_undo)
             |)
          | seeParam(currentAction)
          | seeLocDecl(currentAction)
          | seeSpec(currentAction)
          | seeInOut(currentAction)
          | (| HelpEtiq :: HELPMESS()
             | HelpEtiq ^= true when (currentAction=#C_help)
             |)
          | (| RefrEtiq :: REFRESHING()
             | RefrEtiq ^= true when (currentAction=#C_refresh)
             |)
          | (| WinTEtiq :: WINDOW_TEXTING()
             | WinTEtiq ^= true when (currentAction=#C_text_win)
             |)
          | (| DisPEtiq :: DISPLAYING_PRAGMAS()
             | DisPEtiq ^= true when (currentAction=#C_pragm)
             |)
          | libraryManagement{}
          |)
         where 
         label HelpEtiq, WinTEtiq, DisPEtiq, RefrEtiq, UndoEtiq; 
         process seeParam =
              ( ? action_type currentAction;
              )
            (| (| p := getSelectedProc()
                | p ^= true when (currentAction=#C_param)
                | seeingParam(p)
                |)/ p |)
            where 
            ntrees p;
            end
         ; 
         process seeLocDecl =
              ( ? action_type currentAction;
              )
            (| (| p := getSelectedProc()
                | p ^= true when (currentAction=#C_locDecl)
                | seeingLocDecl(p)
                |)/ p |)
            where 
            ntrees p;
            end
         ; 
         process seeSpec =
              ( ? action_type currentAction;
              )
            (| (| p := getSelectedProc()
                | p ^= true when (currentAction=#C_spec)
                | CREATING_SPEC(p)
                |)/ p |)
            where 
            ntrees p;
            end
         ; 
         process seeInOut =
              ( ? action_type currentAction;
              )
            (| (| p := getSelectedProc()
                | p ^= true when (currentAction=#C_inOut)
                | seeingInOut(p)
                |)/ p |)
            where 
            ntrees p;
            end
         ; 
         process libraryManagement =
              ( ? action_type currentAction;
              )
            (| seeInfoIcon{}
             | removeLibrary{}
             | reloadLibrary{}
             |)
            where 
            process seeInfoIcon =
                 ( ? action_type currentAction;
                 )
               (| (| linfo_IconLibrary :: DISPLAYINGINFO_ICON{}
                   | linfo_IconLibrary ^= [:currentAction=#C_info_Icon]
                   |) |)
               where 
               label linfo_IconLibrary;
               end
            ; 
            process removeLibrary =
                 ( ? action_type currentAction;
                 )
               (| (| e :: removeLib{}
                   | e ^= [:currentAction=#C_removeLib]
                   |) |)
               where 
               label e;
               end
            ; 
            process reloadLibrary =
                 ( ? action_type currentAction;
                 )
               (| (| e :: reloadLib{}
                   | e ^= [:currentAction=#C_reloadLib]
                   |) |)
               where 
               label e;
               end
            ;
            end
         ;
         end
      ; 
      process CONFIRM =
           ( ? action_type currentAction;
             ! action_type CONFIRM;
           )
         (| CONFIRM := CONFIRMING()
          | CONFIRM ^= true when (currentAction=#C_confirm) %dans TextWindow%
          |)
      ; 
      action_type currentAction; 
      DRAW, EDIT;
      end
   ; 
   process MEMORISE =
        ( ? boolean END_NON_REMANENT; 
            action_type REMANENT; 
            action_type NON_REMANENT; 
            mouse_type MOUSE_BUTTON;
          ! action_type ON; 
            event START_REMANENT; 
            event START_ACTION;
        )
      (| (| (| MEMOIRE{}
             | ON := ZACTION
             |) where action_type ZACTION; end
	  %  | (| H::TRACE("THIS_ACTION" when ^THIS_ACTION, THIS_ACTION) | H ^= THIS_ACTION |) where label H; end %
          | AFFICHAGE(THIS_ACTION)
          | START_ACTION := NON_REMANENT ^+ REMANENT
          |)/ THIS_ACTION |)
      where 
      process MEMOIRE =
           ( ? boolean END_NON_REMANENT; 
               action_type REMANENT; 
               action_type NON_REMANENT; 
               mouse_type MOUSE_BUTTON;
             ! action_type THIS_ACTION; 
               action_type ZACTION; 
               event START_REMANENT; 
               event START_ACTION;
           )
         (| MEMORY ^= REMANENT ^+ END_NON_REMANENT
          | MEMORY := REMANENT default (MEMORY$1 init #C_no_action)
          | THIS_ACTION ^= NON_REMANENT ^+ MEMORY ^+ MOUSE_BUTTON
          | THIS_ACTION := NON_REMANENT default REMANENT default (MEMORY when END_NON_REMANENT) default ZACTION
          | ZACTION := THIS_ACTION$1 init #C_no_action
          | START_REMANENT := ^REMANENT
          |)
         where 
         action_type MEMORY, ZMEMORY;
         end
      ; 
      process AFFICHAGE =
           ( ? action_type THIS_ACTION;
           )
      
      ; 
      action_type THIS_ACTION;
      end
   ; 
   process VEILLE =
        ( ? event START_ACTION; 
            action_type ASSOCIATE_PORT; 
            boolean INHIBIT; 
            action_type ON; 
            mouse_type MOUSE_BUTTON; 
            event START_REMANENT;
          ! event FIRST_CLICK; 
            action_type ON_ACTION; 
            integer X; 
            integer Y;
        )
      (| (| (| MOUSE_BUTTON_DA := B1
             | ON_DA := SON_2
             | DEFINE_ACTION{}
             |) where action_type ON_DA; 
                      mouse_type MOUSE_BUTTON_DA; end
          | (| MOUSE_BUTTON := B2
             | ADRESSAGE_CREATION{}
             |) where mouse_type MOUSE_BUTTON; end
          | (| ON_D := SON_4
             | DISPATCH{}
             | SON_2 := SON
             |) where action_type SON, ON_D; end
          | ON_ACTION := ON_ACTION_AC default ON_ACTION_DA
          | (| ANNULATION(0 when START_ACTION)
             | FIRST_CLICK := START_ACTION
             |)
          | (| FILTER_INHIBIT{}
             | SON_4 := SON
             |) where action_type SON; end
          | (| E := MOUSE_BUTTON
             | (| (OBJ, TYP_OBJ) := GET_OBJ(X, Y)
                | (X, Y) := GET_XY(E)
                |)
             |) where mouse_type E; end
          |)/ OBJ, TYP_OBJ, SON_4, ON_ACTION_AC, B2, B1, SON_2, ON_ACTION_DA |)
      where 
      process DEFINE_ACTION =
           ( ? action_type ON_DA; 
               event START_ACTION; 
               mouse_type MOUSE_BUTTON_DA; 
               objet_type TYP_OBJ;
             ! action_type ON_ACTION_DA;
           )
         (| (| IS_BOX := PASTE_BOITE()
             | IS_BOX ^= ON_DA
             |)
          | (| MAP_BOX := [:ON_DA=#C_bte_map] when (TYP_OBJ=#typ_bte)
             | EMB_COMP := [:ON_DA=#C_embed] when (TYP_OBJ=#typ_bte)
             | SIMPLE_CLICK := ([:(ON_DA=#C_cut_graph) or (ON_DA=#C_halo) or (ON_DA=#C_decaps) or (ON_DA=#C_copy_Icon) or (ON_DA=#C_copy_graph) or (ON_DA=#C_selection)] default ([:ON_DA=#C_paste_graph] when (not IS_BOX)) default MAP_BOX default EMB_COMP) when (MOUSE_BUTTON_DA=#left)
             |)
          | (| MOVE := [:ON_DA=#C_move] when ((TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_seg) or (TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_port_ext))
             | RESIZE := [:ON_DA=#C_resize] when ((TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_port))
             | PASTE := [:ON_DA=#C_paste_graph] when (TYP_OBJ=#typ_vide) when IS_BOX
             | JUSTIFY := [:ON_DA=#C_justif] when ((TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_cadre))
             | GLUE := [:ON_DA=#C_encaps] when (TYP_OBJ=#typ_vide)
             | MAP_LINK := [:ON_DA=#C_link_map] when ((TYP_OBJ=#typ_seg) or (TYP_OBJ=#typ_port))
             | FIRST_CLICK_FOR_MULTIPLE := (MOVE default RESIZE default PASTE default JUSTIFY default GLUE default MAP_LINK) when (MOUSE_BUTTON_DA=#left) when (not ZACTIVE_MULTIPLE)
             |)
          | SECOND_CLICK := [:(ON_DA=#C_justif) or (ON_DA=#C_link_map)] when (MOUSE_BUTTON_DA=#left) when ZACTIVE_MULTIPLE
          | (| ACTIVE_MULTIPLE ^= START_ACTION ^+ MOUSE_BUTTON_DA
             | ACTIVE_MULTIPLE := (not START_ACTION) default (not SECOND_CLICK) default FIRST_CLICK_FOR_MULTIPLE default (not [:(MOUSE_BUTTON_DA=#right) or (MOUSE_BUTTON_DA=#middle)]) default ZACTIVE_MULTIPLE
             | ZACTIVE_MULTIPLE := ACTIVE_MULTIPLE$1 init false
             |)
          | VALIDATE_PORT := [:ON_DA=#C_cliqportnom] when (^MOUSE_BUTTON_DA)
          | ON_ACTION_DA := (#C_no_action when START_ACTION) default (ON_DA when (SIMPLE_CLICK default VALIDATE_PORT default [:ACTIVE_MULTIPLE/=ZACTIVE_MULTIPLE])) default (#C_move_in_hierar when (not ACTIVE_MULTIPLE))
          |)
         where 
         boolean IS_BOX, ACTIVE_MULTIPLE, ZACTIVE_MULTIPLE; 
         event MAP_BOX, EMB_COMP, MOVE, RESIZE, PASTE, JUSTIFY, GLUE, MAP_LINK; 
         event SIMPLE_CLICK, FIRST_CLICK_FOR_MULTIPLE, SECOND_CLICK, VALIDATE_PORT; 
         process PASTE_BOITE =
              ( ! boolean S;
              )
         
         ;
         end
      ; 
      process DISPATCH =
           ( ? action_type ON_D; 
               mouse_type MOUSE_BUTTON;
             ! action_type SON; 
               mouse_type B1; 
               mouse_type B2;
           )
         (| SON := ON_D when (ON_D/=#C_creer)
          | B1 := MOUSE_BUTTON when (ON_D/=#C_creer)
          | B2 := MOUSE_BUTTON when (ON_D=#C_creer)
          |)
      ; 
      process ANNULATION =
           ( ? integer ANNULE;
           )
      
      ; 
      process FILTER_INHIBIT =
           ( ? action_type ASSOCIATE_PORT; 
               boolean INHIBIT; 
               action_type ON; 
               mouse_type MOUSE_BUTTON;
             ! action_type SON;
           )
         (| INHIBITED ^= ON ^+ MOUSE_BUTTON ^+ ASSOCIATE_PORT
          | INHIBITED := [:INHIBIT] default (not [:MOUSE_BUTTON=#right]) default (not (^ASSOCIATE_PORT)) default ZINHIBITED
          | ZINHIBITED := INHIBITED$1 init false
          | SON := (ON when (not ZINHIBITED)) default (ON when (^ASSOCIATE_PORT)) default (#C_move_in_hierar when (MOUSE_BUTTON=#right))
          |)
         where 
         boolean INHIBITED, ZINHIBITED;
         end
      ; 
      process ADRESSAGE_CREATION =
           ( ? mouse_type MOUSE_BUTTON; 
               event START_REMANENT; 
               integer OBJ; 
               objet_type TYP_OBJ;
             ! action_type ON_ACTION_AC;
           )
         (| CREER_LIEN ^= CREER_BOITE ^= REPOS ^= START_REMANENT ^+ MOUSE_BUTTON
          | REPOS := START_REMANENT default ([:(MOUSE_BUTTON=#middle) or (MOUSE_BUTTON=#right)] when (not ZREPOS)) default (((TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_port_ext) or (TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_cadre)) when (MOUSE_BUTTON=#left) when (not 
                     ZREPOS)) default ((not ([:MOUSE_BUTTON=#left] when ((OBJ=0) or (TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_port_ext)))) when ZREPOS) default ZREPOS
          | ZREPOS := REPOS$1 init true
          | CREER_LIEN := (not START_REMANENT) default (((TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_port_ext)) when (MOUSE_BUTTON=#left) when ZREPOS) default ((not ((TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_port_ext) or (TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_cadre))) 
                          when (MOUSE_BUTTON=#left) when ZCREER_LIEN) default ((MOUSE_BUTTON=#left) when ZCREER_LIEN) default (not [:(MOUSE_BUTTON=#middle) or (MOUSE_BUTTON=#right)]) default ZCREER_LIEN
          | ZCREER_LIEN := CREER_LIEN$1 init false
          | CREER_PORT := [:(TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_cadre)] when (MOUSE_BUTTON=#left) when REPOS
          | CREER_BOITE := (not START_REMANENT) default ((OBJ=0) when (MOUSE_BUTTON=#left) when ZREPOS) default (not [:(MOUSE_BUTTON=#middle) or (MOUSE_BUTTON=#right)]) default ZCREER_BOITE
          | ZCREER_BOITE := CREER_BOITE$1 init false
          | ON_ACTION_AC := (#C_no_action when START_REMANENT) default (#C_creerlien when (CREER_LIEN or (CREER_LIEN/=ZCREER_LIEN))) default (#C_creerport when CREER_PORT) default (#C_creerbte when (CREER_BOITE/=ZCREER_BOITE)) default (#C_move_in_hierar when 
                         REPOS)
          |)
         where 
         event CREER_PORT; 
         boolean CREER_LIEN, ZCREER_LIEN, CREER_BOITE, ZCREER_BOITE, REPOS, ZREPOS;
         end
      ; 
      action_type ON_ACTION_1, SON_2, SON, ON_ACTION_3, SON_4; 
      mouse_type B1, B2; 
      objet_type TYP_OBJ; 
      integer OBJ;
      end
   ; 
   process MOUSE =
        ( ? event HE;
          ! mouse_type MOUSE_BUTTON;
        )
      (| (| (| ignore := IS_MODULE() or IS_ROOT()
             | ignore ^= HE
             | S := MOUSE_DOWN_IN_GE(HE when (not ignore))
             |)
          | E := [:S]
          | MOUSE_BUTTON := GET_BUTTON(E)
          |)/ E, S |)
      where 
      boolean S, ignore; 
      process MOUSE_DOWN_IN_GE =
           ( ? event HE;
             ! boolean S;
           )
           spec (| HE ^= S |)
      
      ; 
      process GET_BUTTON =
           ( ? event E;
             ! mouse_type BUTTON;
           )
           spec (| E ^= BUTTON |)
      
      ; 
      event E;
      end
   ; 
   process FEED_BACK =
        ( ? event endNonRem; 
            event END_VALIDATE_PORTS; 
            mouse_type MOUSE_BUTTON;
          ! boolean END_NON_REMANENT;
        )
      (| FIN_CLIQUER ^= MOUSE_BUTTON
       | FIN_CLIQUER := END_VALIDATE_PORTS default false
       | END_NON_REMANENT := endNonRem default FIN_CLIQUER
       | ZEND_NON_REMANENT := END_NON_REMANENT$1 init false
       |)
      where 
      boolean ZEND_NON_REMANENT, FIN_CLIQUER;
      end
   ; 
   process CANVAS =
        ( ? action_type ON_ACTION; 
            mouse_type MOUSE_BUTTON; 
            integer X; 
            integer Y; 
            event FIRST_CLICK;
          ! boolean INHIBIT; 
            event endNonRem; 
            event END_VALIDATE_PORTS;
        )
      (| DEPLACEMENT{}
       | CLIQUER_PORT{}
       | SIMPLES{}
       | MULTIPLES{}
       | CREER{}
       |)
      where 
      process DEPLACEMENT =
           ( ? action_type ON_ACTION; 
               mouse_type MOUSE_BUTTON; 
               integer X; 
               integer Y;
             ! boolean INHIBIT;
           )
         (| (| (| E3 := Y
                | E2 := X
                | E1 := MOUSE_BUTTON
                | A := ON_ACTION
                | ADRESSE{#C_move_in_hierar}
                |) where action_type A; 
                         mouse_type E1; 
                         integer E2, E3; end
             | (| Y := S3
                | X := S2
                | BUTTON := S1
                | (| SX := X when (BUTTON=#middle)
                   | SY := Y when (BUTTON=#middle)
                   |)
                | SX_1 := SX
                | SY_2 := SY
                |) where mouse_type BUTTON; 
                         integer X, Y, SX, SY; end
             | (| Y := SY_2
                | X := SX_1
                | GET_OBJ{}
                |) where integer X, Y; end
             | TEST_DEP{}
             | (| GO_DOWN{}
                | INHIBE_3 := INHIBE
                |) where boolean INHIBE; end
             | (| Y := S3
                | X := S2
                | BUTTON := S1
                | WHEN_BUTTON{#right}
                | SX_4 := SX
                |) where mouse_type BUTTON; 
                         integer X, Y, SX; end/ SY
             | (| REMONTE := SX_4
                | GO_UP{}
                |) where integer REMONTE; end
             | (| I := INHIBE_3
                | INHIBE := NONDSBOITE default I
                | INHIBIT := INHIBE
                |) where boolean INHIBE, I; end
             |)/ SX_4, INHIBE_3, DESCEND, NONDSBOITE, TYP_OBJ, OBJ, SY_2, SX_1, S3, S2, S1 |)
         where 
         process GO_DOWN =
              ( ? integer DESCEND;
                ! boolean INHIBE;
              )
              spec (| DESCEND ^= INHIBE |)
         
         ; 
         process GO_UP =
              ( ? integer REMONTE;
              )
         
         ; 
         process TEST_DEP =
              ( ? integer OBJ; 
                  objet_type TYP_OBJ;
                ! integer DESCEND; 
                  event NONDSBOITE;
              )
            (| DESCEND := OBJ when ((OBJ/=0) and (TYP_OBJ/=#typ_seg) and (TYP_OBJ/=#typ_cadre))
             | NONDSBOITE := [:TYP_OBJ/=#typ_bte] when (^DESCEND)
             |)
         ; 
         mouse_type S1; 
         integer S2, S3, SX_1, SX, SY_2, SY, OBJ, DESCEND, SX_4; 
         objet_type TYP_OBJ; 
         event NONDSBOITE; 
         boolean INHIBE_3, INHIBE;
         end
      ; 
      process ADRESSE =
           { action_type N; }
           ( ? action_type A; 
               mouse_type E1; 
               integer E2; 
               integer E3;
             ! mouse_type S1; 
               integer S2; 
               integer S3;
           )
         (| S1 := E1 when (A=N)
          | S2 := E2 when (A=N)
          | S3 := E3 when (A=N)
          |)
      ; 
      process WHEN_BUTTON =
           { mouse_type N; }
           ( ? mouse_type BUTTON; 
               integer X; 
               integer Y;
             ! integer SX; 
               integer SY;
           )
         (| SX := X when (BUTTON=N)
          | SY := Y when (BUTTON=N)
          |)
      ; 
      process CLIQUER_PORT =
           ( ? action_type ON_ACTION; 
               mouse_type MOUSE_BUTTON; 
               integer X; 
               integer Y;
             ! event END_VALIDATE_PORTS;
           )
         (| (| (| E3 := Y
                | E2 := X
                | E1 := MOUSE_BUTTON
                | A := ON_ACTION
                | ADRESSE{#C_cliqportnom}
                |) where action_type A; 
                         mouse_type E1; 
                         integer E2, E3; end
             | (| Y := S3
                | X := S2
                | BUTTON := S1
                | WHEN_BUTTON{#left}
                | SX_1 := SX
                | SY_2 := SY
                |) where mouse_type BUTTON; 
                         integer X, Y, SX, SY; end
             | (| Y := SY_2
                | X := SX_1
                | GET_OBJ{}
                |) where integer X, Y; end
             | (| Y := SY_2
                | X := SX_1
                | VALIDER_PORT{}
                | PLUS_DE_PORT_3 := PLUS_DE_PORT
                |) where integer X, Y; 
                         boolean PLUS_DE_PORT; end
             | (| Y := S3
                | X := S2
                | BUTTON := S1
                | WHEN_BUTTON{#right}
                | SX_4 := SX
                |) where mouse_type BUTTON; 
                         integer X, Y, SX; end/ SY
             | (| Y := S3
                | X := S2
                | BUTTON := S1
                | WHEN_BUTTON{#middle}
                | SX_5 := SX
                |) where mouse_type BUTTON; 
                         integer X, Y, SX; end/ SY
             | (| PASSE := SX_5
                | PASSER_PORT{}
                | PLUS_DE_PORT_6 := PLUS_DE_PORT
                |) where integer PASSE; 
                         boolean PLUS_DE_PORT; end
             | (| FIN2 := PLUS_DE_PORT_6
                | ANNULER := SX_4
                | FIN1 := PLUS_DE_PORT_3
                | MERGE_CLIQUER{}
                | END_VALIDATE_PORTS := FIN_CLIQUE
                |) where event FIN_CLIQUE; 
                         boolean FIN1, FIN2; 
                         integer ANNULER; end
             | (| CACHE := END_VALIDATE_PORTS
                | CACHE_TEXTE{}
                |) where event CACHE; end
             |)/ PLUS_DE_PORT_6, SX_5, SX_4, PLUS_DE_PORT_3, TYP_OBJ, OBJ, SY_2, SX_1, S3, S2, S1 |)
         where 
         process VALIDER_PORT =
              ( ? integer X; 
                  integer Y; 
                  integer OBJ; 
                  objet_type TYP_OBJ;
                ! boolean PLUS_DE_PORT;
              )
              spec (| X ^= Y ^= OBJ ^= TYP_OBJ ^= PLUS_DE_PORT |)
         
         ; 
         process PASSER_PORT =
              ( ? integer PASSE;
                ! boolean PLUS_DE_PORT;
              )
              spec (| PASSE ^= PLUS_DE_PORT |)
         
         ; 
         process MERGE_CLIQUER =
              ( ? boolean FIN1; 
                  boolean FIN2; 
                  integer ANNULER;
                ! event FIN_CLIQUE;
              )
            (| FIN_CLIQUE := [:FIN1] default [:FIN2] default (^ANNULER) |)
         ; 
         process CACHE_TEXTE =
              ( ? event CACHE;
              )
         
         ; 
         mouse_type S1; 
         integer S2, S3, SX_1, SX, SY_2, SY, OBJ, SX_4, SX_5; 
         objet_type TYP_OBJ; 
         boolean PLUS_DE_PORT_3, PLUS_DE_PORT, PLUS_DE_PORT_6;
         end
      ; 
      process SIMPLES =
           ( ? action_type ON_ACTION; 
               mouse_type MOUSE_BUTTON; 
               integer X; 
               integer Y;
             ! event endNonRem;
           )
         (| (| HALO{}
             | PROFIL{}
             | CUT{}
             | COPY{}
             | BREAK{}
             | SELECT{}
             | MAP_BTE{}
             | EMBED_CREATE{}
             | COPY_ICON{}
             | endNonRem := endMap default endCopy
             |)/ endMap, endCopy |)
         where 
         process HALO =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_halo}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | GET_OBJ{}
                   | OBJ_1 := OBJ
                   | TYP_OBJ_2 := TYP_OBJ
                   |) where integer X, Y, OBJ; 
                            objet_type TYP_OBJ; end
                | (| TYP_OBJ := TYP_OBJ_2
                   | OBJ := OBJ_1
                   | TEST_HALO{}
                   |) where integer OBJ; 
                            objet_type TYP_OBJ; end
                | (| TYP_OBJ := STYP_OBJ
                   | OBJ := SOBJ
                   | SHOW_HALO{}
                   |) where integer OBJ; 
                            objet_type TYP_OBJ; end
                |)/ STYP_OBJ, SOBJ, TYP_OBJ_2, OBJ_1, SY, SX, S3, S2, S1 |)
            where 
            process SHOW_HALO =
                 ( ? integer OBJ; 
                     objet_type TYP_OBJ;
                 )
                 spec (| OBJ ^= TYP_OBJ |)
            
            ; 
            process TEST_HALO =
                 ( ? integer OBJ; 
                     objet_type TYP_OBJ;
                   ! integer SOBJ; 
                     objet_type STYP_OBJ;
                 )
               (| VISUALISE := [:(OBJ=0) or (TYP_OBJ=#typ_bte) or (TYP_OBJ=#typ_seg) or (TYP_OBJ=#typ_port) or (TYP_OBJ=#typ_port_ext)]
                | SOBJ := OBJ when VISUALISE
                | STYP_OBJ := TYP_OBJ when VISUALISE
                |)
               where 
               event VISUALISE;
               end
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY, OBJ_1, OBJ, SOBJ; 
            objet_type TYP_OBJ_2, TYP_OBJ, STYP_OBJ;
            end
         ; 
         process PROFIL =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_move_in_hierar}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#ctrl_middle}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | GET_OBJ{}
                   |) where integer X, Y; end
                | TEST_PROFIL{}
                | SEE_PROFIL{}
                |)/ VISUALISE, TYP_OBJ, OBJ, SY, SX, S3, S2, S1 |)
            where 
            process SEE_PROFIL =
                 ( ? integer VISUALISE;
                 )
            
            ; 
            process TEST_PROFIL =
                 ( ? integer OBJ; 
                     objet_type TYP_OBJ;
                   ! integer VISUALISE;
                 )
               (| VISUALISE := OBJ when (TYP_OBJ=#typ_bte) |)
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY, OBJ, VISUALISE; 
            objet_type TYP_OBJ;
            end
         ; 
         process CUT =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_cut_graph}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | CUTTING{}
                   |) where integer X, Y; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process CUTTING =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ; 
         process BREAK =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_decaps}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | BREAKING{}
                   |) where integer X, Y; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process BREAKING =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ; 
         process COPY =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
                ! event endCopy;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_copy_graph}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | COPYING{}
                   |) where integer X, Y; end
                | (| E := SX
                   | S := ^E
                   | endCopy := S
                   |) where event S; 
                            integer E; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process COPYING =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ; 
         process SELECT =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_selection}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | SELECTING{}
                   |) where integer X, Y; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process SELECTING =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ; 
         process MAP_BTE =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
                ! event endMap;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_bte_map}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | MAPPING_BTE{}
                   |) where integer X, Y; end
                | (| E := SX
                   | S := ^E
                   | endMap := S
                   |) where event S; 
                            integer E; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process MAPPING_BTE =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ; 
         process EMBED_CREATE =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_embed}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | GET_OBJ{}
                   |) where integer X, Y; end/ TYP_OBJ
                | (| bte := OBJ
                   | EMBEDDED_CREATING{}
                   |) where integer bte; end
                | EMBEDDED_COMPILING{}(tree when ok)
                |)/ tree, ok, OBJ, SY, SX, S3, S2, S1 |)
            where 
            process EMBEDDED_CREATING =
                 ( ? integer bte;
                   ! ntrees tree; 
                     boolean ok;
                 )
                 spec (| bte ^= tree ^= ok |)
            
            ; 
            process EMBEDDED_COMPILING =
                 ( ? ntrees tree;
                 )
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY, OBJ; 
            objet_type TYP_OBJ; 
            boolean ok; 
            ntrees tree;
            end
         ; 
         process COPY_ICON =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_copy_Icon}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | COPYING_ICON{}
                   |) where integer X, Y; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process COPYING_ICON =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ;
         end
      ; 
      process MULTIPLES =
           ( ? action_type ON_ACTION; 
               mouse_type MOUSE_BUTTON; 
               integer Y; 
               integer X; 
               event FIRST_CLICK;
           )
         (| (| MOVE{}
             | RESIZE{}
             | GLUE{}
             | JUSTIFY{}
             | PASTE{}
             | MAP_LIEN{}
             |) |)
         where 
         process MOVE =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_move}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#middle}
                   | SX_1 := SX
                   | SY_2 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   | SX_3 := SX
                   | SY_4 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#right}
                   | SX_5 := SX
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX; end/ SY
                | (| ETAT := N_6
                   | Y := SY_4
                   | X := SX_3
                   | MOVING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 1
                   | N_6 := N
                   |) where integer N; end
                | (| ETAT := N_7
                   | Y := SY_2
                   | X := SX_1
                   | MOVING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 2
                   | N_7 := N
                   |) where integer N; end
                | (| ANNULE := SX_5
                   | ANNULATION{}
                   |) where integer ANNULE; end
                |)/ N_7, N_6, SX_5, SY_4, SX_3, SY_2, SX_1, S3, S2, S1 |)
            where 
            process MOVING =
                 ( ? integer ETAT; 
                     integer X; 
                     integer Y;
                 )
                 spec (| ETAT ^= Y ^= X |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX_1, SX, SY_2, SY, SX_3, SY_4, SX_5, N_6, N, N_7;
            end
         ; 
         process RESIZE =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_resize}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#middle}
                   | SX_1 := SX
                   | SY_2 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   | SX_3 := SX
                   | SY_4 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#right}
                   | SX_5 := SX
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX; end/ SY
                | (| ETAT := N_6
                   | Y := SY_4
                   | X := SX_3
                   | RESIZING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 1
                   | N_6 := N
                   |) where integer N; end
                | (| ETAT := N_7
                   | Y := SY_2
                   | X := SX_1
                   | RESIZING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 2
                   | N_7 := N
                   |) where integer N; end
                | (| ANNULE := SX_5
                   | ANNULATION{}
                   |) where integer ANNULE; end
                |)/ N_7, N_6, SX_5, SY_4, SX_3, SY_2, SX_1, S3, S2, S1 |)
            where 
            process RESIZING =
                 ( ? integer ETAT; 
                     integer X; 
                     integer Y;
                 )
                 spec (| ETAT ^= Y ^= X |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX_1, SX, SY_2, SY, SX_3, SY_4, SX_5, N_6, N, N_7;
            end
         ; 
         process GLUE =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_encaps}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#middle}
                   | SX_1 := SX
                   | SY_2 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   | SX_3 := SX
                   | SY_4 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#right}
                   | SX_5 := SX
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX; end/ SY
                | (| ETAT := N_6
                   | Y := SY_4
                   | X := SX_3
                   | GLUING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 1
                   | N_6 := N
                   |) where integer N; end
                | (| ETAT := N_7
                   | Y := SY_2
                   | X := SX_1
                   | GLUING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 2
                   | N_7 := N
                   |) where integer N; end
                | (| ANNULE := SX_5
                   | ANNULATION{}
                   |) where integer ANNULE; end
                |)/ N_7, N_6, SX_5, SY_4, SX_3, SY_2, SX_1, S3, S2, S1 |)
            where 
            process GLUING =
                 ( ? integer ETAT; 
                     integer X; 
                     integer Y;
                 )
                 spec (| ETAT ^= Y ^= X |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX_1, SX, SY_2, SY, SX_3, SY_4, SX_5, N_6, N, N_7;
            end
         ; 
         process JUSTIFY =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y; 
                  event FIRST_CLICK;
              )
            (| (| (| A := ON_ACTION
                   | (| cond := [:A=#C_justif]
                      | S1 := MOUSE_BUTTON when cond
                      | S2 := X when cond
                      | S3 := Y when cond
                      | etat_cou := (false when FIRST_CLICK) default ((not zetat) when cond)
                      | zetat := etat_cou$1 init false
                      | etat_trans := etat_cou when cond
                      | etat_cou ^= FIRST_CLICK ^+ cond
                      |)
                   |) where action_type A; end
                | (| etat := etat_trans
                   | Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUT{#left}
                   | SX_1 := SX
                   | SY_2 := SY
                   | setat_3 := setat
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; 
                            boolean etat, setat; end/ but
                | (| etat := etat_trans
                   | Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUT{#right}
                   |) where mouse_type BUTTON; 
                            integer X, Y; 
                            boolean etat; end/ but
                                             / SY
                                             / setat
                | (| but := N
                   | setat := setat_3
                   | Y := SY_2
                   | X := SX_1
                   | JUSTIFYING{}
                   |) where integer X, Y, but; 
                            boolean setat; end
                | (| ANNULE := SX
                   | ANNULATION{}
                   |) where integer ANNULE; end
                | N := 1
                |)/ N, SX, setat_3, SY_2, SX_1, etat_trans, S3, S2, S1 |)
            where 
            event cond; 
            boolean setat, setat_3, etat_trans, zetat, etat_cou; 
            process JUSTIFYING =
                 ( ? integer but; 
                     boolean setat; 
                     integer X; 
                     integer Y;
                 )
                 spec (| but ^= setat ^= Y ^= X |)
            
            ; 
            process WHEN_BUT =
                 { mouse_type N; }
                 ( ? mouse_type BUTTON; 
                     integer X; 
                     integer Y; 
                     boolean etat;
                   ! mouse_type but; 
                     integer SX; 
                     integer SY; 
                     boolean setat;
                 )
               (| SX := X when (BUTTON=N)
                | SY := Y when (BUTTON=N)
                | setat := etat when (BUTTON=N)
                | but := BUTTON when (BUTTON=N)
                |)
            ; 
            mouse_type S1, but; 
            integer S2, S3, SX_1, SX, SY_2, SY, N;
            end
         ; 
         process PASTE =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | ADRESSE{#C_paste_graph}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#middle}
                   | SX_1 := SX
                   | SY_2 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   | SX_3 := SX
                   | SY_4 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#right}
                   | SX_5 := SX
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX; end/ SY
                | (| ETAT := N_6
                   | Y := SY_4
                   | X := SX_3
                   | PASTING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 1
                   | N_6 := N
                   |) where integer N; end
                | (| ETAT := N_7
                   | Y := SY_2
                   | X := SX_1
                   | PASTING{}
                   |) where integer X, Y, ETAT; end
                | (| N := 2
                   | N_7 := N
                   |) where integer N; end
                | (| ANNULE := SX_5
                   | ANNULATION{}
                   |) where integer ANNULE; end
                |)/ N_7, N_6, SX_5, SY_4, SX_3, SY_2, SX_1, S3, S2, S1 |)
            where 
            process PASTING =
                 ( ? integer ETAT; 
                     integer X; 
                     integer Y;
                 )
                 spec (| ETAT ^= Y ^= X |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX_1, SX, SY_2, SY, SX_3, SY_4, SX_5, N_6, N, N_7;
            end
         ; 
         process MAP_LIEN =
              ( ? action_type ON_ACTION; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y; 
                  event FIRST_CLICK;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := ON_ACTION
                   | (| cond := [:A=#C_link_map]
                      | S1 := MOUSE_BUTTON when cond
                      | S2 := X when cond
                      | S3 := Y when cond
                      | etat_cou := ((-1) when FIRST_CLICK) default ((zetat+1) when (zetat<2) when cond) default (0 when cond)
                      | zetat := etat_cou$1 init (-1)
                      | etat_trans := etat_cou when cond
                      | etat_cou ^= FIRST_CLICK ^+ cond
                      |)
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| etat := etat_trans
                   | Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUT{#left}
                   | SX_1 := SX
                   | SY_2 := SY
                   | setat_3 := setat
                   |) where mouse_type BUTTON; 
                            integer X, Y, etat, SX, SY, setat; end/ but
                | (| etat := etat_trans
                   | Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUT{#right}
                   |) where mouse_type BUTTON; 
                            integer X, Y, etat; end/ but
                                             / SY
                                             / setat
                | (| but := N
                   | setat := setat_3
                   | Y := SY_2
                   | X := SX_1
                   | MAPPING_LIEN{}
                   |) where integer X, Y, setat, but; end
                | (| ANNULE := SX
                   | ANNULATION{}
                   |) where integer ANNULE; end
                | N := 1
                |)/ N, SX, setat_3, SY_2, SX_1, etat_trans, S3, S2, S1 |)
            where 
            integer N, setat, setat_3, SY, SY_2, SX, SX_1, etat_trans, S3, S2, zetat, etat_cou; 
            event cond; 
            process MAPPING_LIEN =
                 ( ? integer but; 
                     integer setat; 
                     integer X; 
                     integer Y;
                 )
                 spec (| but ^= setat ^= Y ^= X |)
            
            ; 
            process WHEN_BUT =
                 { mouse_type N; }
                 ( ? mouse_type BUTTON; 
                     integer X; 
                     integer Y; 
                     integer etat;
                   ! mouse_type but; 
                     integer SX; 
                     integer SY; 
                     integer setat;
                 )
               (| SX := X when (BUTTON=N)
                | SY := Y when (BUTTON=N)
                | setat := etat when (BUTTON=N)
                | but := BUTTON when (BUTTON=N)
                |)
            ; 
            mouse_type S1, but;
            end
         ;
         end
      ; 
      process CREER =
           ( ? action_type ON_ACTION; 
               mouse_type MOUSE_BUTTON; 
               integer X; 
               integer Y;
           )
         (| (| CREE := ON_ACTION
             | CREER_PORT{}
             |) where action_type CREE; end
          | (| CREE := ON_ACTION
             | CREER_LIEN{}
             |) where action_type CREE; end
          | (| CREE := ON_ACTION
             | CREER_BOITE{}
             |) where action_type CREE; end
          |)
         where 
         process CREER_PORT =
              ( ? action_type CREE; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := CREE
                   | ADRESSE{#C_creerport}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   |) where mouse_type BUTTON; 
                            integer X, Y; end
                | (| Y := SY
                   | X := SX
                   | CREATION_PORT{}
                   |) where integer X, Y; end
                |)/ SY, SX, S3, S2, S1 |)
            where 
            process CREATION_PORT =
                 ( ? integer X, Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX, SY;
            end
         ; 
         process CREER_BOITE =
              ( ? action_type CREE; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := CREE
                   | ADRESSE{#C_creerbte}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   | SX_1 := SX
                   | SY_2 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#middle}
                   | SX_3 := SX
                   | SY_4 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#right}
                   | SX_5 := SX
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX; end/ SY
                | (| THIS_ACTION := N_6
                   | Y := SY_2
                   | X := SX_1
                   | CREATION_BOITE{}
                   |) where integer X, Y, THIS_ACTION; end
                | (| ANNULE := SX_5
                   | ANNULATION{}
                   |) where integer ANNULE; end
                | (| THIS_ACTION := N_7
                   | Y := SY_4
                   | X := SX_3
                   | CREATION_BOITE{}
                   |) where integer X, Y, THIS_ACTION; end
                | (| N := 1
                   | N_6 := N
                   |) where integer N; end
                | (| N := 2
                   | N_7 := N
                   |) where integer N; end
                |)/ N_7, N_6, SX_5, SY_4, SX_3, SY_2, SX_1, S3, S2, S1 |)
            where 
            process CREATION_BOITE =
                 ( ? integer X; 
                     integer Y; 
                     integer THIS_ACTION;
                 )
                 spec (| X ^= Y ^= THIS_ACTION |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX_1, SX, SY_2, SY, SX_3, SY_4, SX_5, N_6, N, N_7;
            end
         ; 
         process CREER_LIEN =
              ( ? action_type CREE; 
                  mouse_type MOUSE_BUTTON; 
                  integer X; 
                  integer Y;
              )
            (| (| (| E3 := Y
                   | E2 := X
                   | E1 := MOUSE_BUTTON
                   | A := CREE
                   | ADRESSE{#C_creerlien}
                   |) where action_type A; 
                            mouse_type E1; 
                            integer E2, E3; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#left}
                   | SX_1 := SX
                   | SY_2 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := SY_2
                   | X := SX_1
                   | CREATION_LIEN{}
                   |) where integer X, Y; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#middle}
                   | SX_3 := SX
                   | SY_4 := SY
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX, SY; end
                | (| Y := S3
                   | X := S2
                   | BUTTON := S1
                   | WHEN_BUTTON{#right}
                   | SX_5 := SX
                   |) where mouse_type BUTTON; 
                            integer X, Y, SX; end/ SY
                | (| Y := SY_4
                   | X := SX_3
                   | CREATION_LIEN{}
                   |) where integer X, Y; end
                | (| ANNULE := SX_5
                   | ANNULATION{}
                   |) where integer ANNULE; end
                |)/ SX_5, SY_4, SX_3, SY_2, SX_1, S3, S2, S1 |)
            where 
            process CREATION_LIEN =
                 ( ? integer X; 
                     integer Y;
                 )
                 spec (| X ^= Y |)
            
            ; 
            mouse_type S1; 
            integer S2, S3, SX_1, SX, SY_2, SY, SX_3, SY_4, SX_5;
            end
         ; 
         process ANNULATION =
              ( ? integer ANNULE;
              )
         
         ;
         end
      ; 
      process ANNULATION =
           ( ? integer ANNULE;
           )
      
      ;
      end
   ; 
   action_type REMANENT, NON_REMANENT, ASSOCIATE_PORT, ON, ON_ACTION; 
   event START_REMANENT, START_ACTION, FIRST_CLICK, endNonRem, END_VALIDATE_PORTS; 
   mouse_type MOUSE_BUTTON; 
   integer X, Y; 
   boolean INHIBIT, END_NON_REMANENT;
   end
; 
