/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
#ifndef __CEXTRACT__
#if __STDC__

public: 
void setRoot(ntrees p);
ntrees getRoot(void);
ntrees getRootProc(ntrees proc);
ntrees sauver_arbre(ntrees arb, boolean destruct);
ntrees dupl_arbre(ntrees arb);
ntrees init_decl(ntrees p_decl);
boolean meme_nom(ntrees p_decl, ntrees p_decl_lie);
boolean meme_sig(ntrees sig1, ntrees sig2);
ntrees get_arb_sig(ntrees *arb_gra);
ntrees get_arb_boite(ntrees arb_sig);
graphObj_type tree_get_graphObj(ntrees arb_obj);
int getMotherBox(ntrees pSig);
int get_no_boite(ntrees arb_sig);
ntrees boite_mere(int no_port);
int no_boite_mere(ntrees port);
int no_boite_proc(ntrees p_proc);
boolean isBoxProc(int no);
ntrees getModel(int no);
boolean isAPort(int obj);
ntrees getPorts(ntrees pBox);
ntrees getFirstPort(ntrees p_bte);
int get_nb_ports(ntrees p_bte);
boolean bte_avec_port(ntrees p_bte);
int nombre_ports_ent(int boite);
int nombre_ports_sor(int boite);
int getNbLeftPorts(int boite);
int getNbRightPorts(int boite);
boolean isPortInBox(ntrees pPort, ntrees pBox);
boolean isExternPort(ntrees bte, ntrees port_ext);
boolean is_connected_port(ntrees port, boolean intern);
int getCoord(ntrees p, int *nbcoord, typcoord *tcoord, int rela);
void setCoord(ntrees pCoord, int x, int y);
ntrees get_chemin(ntrees p_seg);
boolean chemin_simple(ntrees p_chem_seg);
int get_no_port_diff(ntrees seg_ou_chem);
ntrees get_port_diff(ntrees seg_ou_chem);
ntrees createCoordTree(int opform, int nbcoord, typcoord *coord);
graphObj_type creatept_connex(graphObj_type bte, typcoord coord, boolean en_entree, int rg);
ntrees createSeg(typcoord *tcoord, int pt_neg, graphObj_type *noSeg);
graphObj_type createbte(ntrees arb_sig, typcoord *tcoord, int nbcoord);
int createbte_proc (ntrees arb_sig );
ntrees SignalProcCreate (ntrees father, char *c_name, int category, int index );
ntrees SignalModuleCreate (ntrees father, char *c_name );
int createData(typcoord *tcoord, int nbcoord);

#endif
#endif

