/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */

private:

boolean createport_mapping(int bte, int no_port_map, int no_port_lie, int rg);
boolean createports_mapping(int bte, int select_buff[]);
boolean routage_externe_mapping(ntrees p_port1, ntrees p_port2);
boolean createlien_ext_map(int bte, int no_port_map, int rg, ntrees p_decl, ntrees l_ambig);
boolean routage_interne_mapping(int bte, ntrees l_bte_enc);
void createliens_inter_map(ntrees p_port_diff, int no_port_diff, int map_buff[], int i, int *no);
void detr_liens_mapping(int bte, ntrees l_bte_map);
boolean detr_btes_internes ( ntrees p_bte, ntrees p_proc );
void detr_ports_inutiles ( ntrees p_bte, int embedded_bte );
boolean createmapping_bte (int bte, int select_buff[], int nouv_num_buff[] );
void terminer_mapping (int map_buff[] );
void createmapping_lien (ntrees port_diff, ntrees port_recept, int no_port1, int no_port2 );
void nettoyage_attrib ( ntrees p_port );
void add_signal_proc_inte (ntrees p_proc, ntrees p_decl, boolean en_entree );

