/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */

private:
int getUnparseOperation(ptrepstr vsuff);
void set_action_en_cours ( int act_cour );
// void LoadSaveAction ( int action, char *fileName );
boolean readTreeFile ( char * filename, ntrees *p );
void postcomp ( void );
void first_save ( char * filename, ntrees vt );
void lancer_garbage ( void );
boolean treeparser ( char *nom_fich, boolean addedPhylum, ntrees *mpp );
boolean mkParserFile ( text_win_type w );
void manageHierarTextWin ( ntrees proc_cour, ntrees mpp );
boolean isGraphicalFile ( char *nomfich );
boolean isCorrectFileName(char *filePathString);
boolean isReadableFile(char *filePathString);
boolean is_dotSuffixed(const char *stringModel, int lgString, const char * suffix, int lgSuffix);
char *build_filePathName(const char *pathString, const char * suffix, ntrees proc);
int save_model(char *nomfich, ntrees sourceTree);
int save_model(char *nomfich);
int unparseAs_model( char *nomfich );
int load_model( char *nomfich, int action, boolean setInAtEnd);
int load_library(char *nomfich);
int parse_model ( char *nomfich, int action, boolean setInAtEnd);
void displayParam ( char *parameterFileName );
void setPhylum ( integer phylum );
void decompTextWin ( text_win_type w, ntrees p );
void edit_profil ( text_win_type CanvasText, int obj );
boolean mkTreeFromWindowText ( text_win_type w, ntrees *mpp );
void setCompilerOutputDir(ntrees p);
char* getCompleteNameCurrentDir ( char * vname );
void DebugPrint ( ntrees p );
boolean isNameReadyForCompiling ( ntrees pComp );
void splitCharToArray(char *voptions, int *nb, char *vopt[]);
char* subString(const char *str, int ifrom, int size);

