/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
/* @Begin_prog@ */
#include "pKio.h"
#include "polychronyExitStatus.h"
#include "messignalTables.h"
#include "classReferences.h"
#include "common_type.h"
#include "stringmemStr_type.h"
#include "stringmemRegister_type.h"
#include "GHDC_type.h"
#include "opersignal.h"
#include "string_type.h"
#include "buffer_type.h"
#include "tabtools_type.h"
#include "kernel_type.h"
#include "sysfile_type.h"

#include "DCG_sch.h"
#include "DCG_flat.h"

#include "tree_api.h"
#include "signal_tree.h"
#include "inteattr_g.h"
#include "sigparse_g.h"
#include "messenger.h"
#include "SignalPrinter.h"
#include "SSME_Printer.h"
#include "string.h"
#include "string_api.h"
#include "buffer.h"
#include "ident_g.h"
#include "predefSignalNames_g.h"
#include "atpileIni_g.h"
#include "decsig_g.h"
#include "atInodesList_g.h"
#include "const_i.h"
#include "phylaSignal.h"
#include "javaConstants.h"
#include "SUPERVISEUR_types.h"
typedef void* typeDCG;

#include "graphicalTypes.h"
#include "typ_acces.h"
#include "const_gra_i.h"
#include "currentObjectsManager.h"
#include "builder.h"
#include "SignalDisplaying.h"
#include "graphicalTrees.h"
#include "graphicTablesManager.h"
#include "graphic2Text.h"
#include "message.h"
#include "systemFrontEnd_g.h"
#include "sysfile_g.h"
#include "sysfileRepfil_g.h"
#include "sysfile_graphical_g.h"
#include "simuResolv_g.h"
#include "biblio_g.h"
#include "undo.h"
#include "drawing.h"
#include "SUPERVISEUR_body.h"
#include "LiaisonSignalC2Java_g.h"
#include "interfSignalC_g.h"
#include "OptionManager.h"
#include "BatchCompiler.h"

#include "supervis.h"
#include "supervis_m.c"

#include "supervis_sig_g.c"
#include "supervis_sigCompiler_i.c"
#include "supervis_sigCompiler_interactive_g.c"
#include "supervis_sigCompiler_g.c"
#include "supervis_g.c"
