 /*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */


package common;


// These values must be equal to the values declared in supervis_sigCompiler_i.c.
public class CompilerConst {
    public final static int nbCompFunc = 11; // number of fonctionalities of the Signal Compiler in interactive mode (without generators).
    public final static int nbGenFunc = 7;   // number of fonctionalities of the Signal Compiler in interactive mode for the code generators.
    public final static int nbOptionsAutomatic = 24; // number of fonctionalities of the Signal Compiler in automatic mode.
    public final static int AllFuncInteractive = nbCompFunc + nbGenFunc;
    public final static int AllFunc = AllFuncInteractive + nbOptionsAutomatic;
}
