/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
public:

boolean MOUSE_DOWN_IN_GE ( void );
int ReadMenuButton ( void );
boolean SAVE_DOWN ( void );
boolean BUILD_RESOLV_DOWN ( void );
void GET_OBJ ( int x, int y, int *obj, objet_type *typ_obj );
void GET_XY ( mouse_type e, int *x, int *y );
ntrees getSelectedProc ( void );
mouse_type GET_BUTTON ( void );
boolean PASTE_BOITE ( void );
void PASTING ( int action, int x, int y );
void COPYING ( int x, int y );
void COPYING_ICON ( int x, int y );
void DISPLAYINGINFO_ICON ( void );
void removeLibrary ( void );
int reloadLibrary ( void );
void CREATION_BOITE ( int x, int y, int action );
void CREATION_LIEN ( int x, int y );
void CREATION_PORT ( int x, int y );
void JUSTIFYING ( int but, int etat, int x, int y );
void GLUING ( int action, int x, int y );
void RESIZING ( int action, int x, int y );
void MOVING ( int action, int x, int y );
void BREAKING ( int x, int y );
void CUTTING ( int x, int y );
void razSelectBuf ( void );
void SELECTING ( int x, int y );
void MAPPING_BTE ( int x, int y );
void END_MAPPING ( void );
void MAPPING_LIEN ( int but, int etat, int x, int y );
void changeModelCat ( ntrees t, action_type ty_ch );
void RECUP_IDENTS ( ptident *ident1, ptident *ident2 );
void REPLACING_IDENT ( ntrees p, ptident ident1, ptident ident2 );
void SEE_PROFIL ( int obj );
void SHOW_HALO ( int obj, objet_type typ_obj );
boolean VALIDER_PORT ( int x, int y, int obj, objet_type typ_obj );
boolean PASSER_PORT ( int passe );
void CACHE_TEXTE ( void );
void GO_UP ( int remonte );
boolean GO_DOWN ( int obj );
void DISPLAYING_PRAGMAS ( void );
void seeingParam ( ntrees p );
void CREATING_SPEC ( ntrees p );
void seeingLocDecl ( ntrees p );
void seeingInOut ( ntrees p );
void AFFICHAGE ( action_type action );
void TRACE ( char * message, action_type on_action );
void UNDOING ( void );
void REFRESHING ( void );
void WINDOW_TEXTING ( void );
action_type CONFIRMING ( void );
void DISPLAYING_POLICE ( action_type act );
void DISPLAYING_NAMES ( boolean nom_port );
void DISPLAYING_DETAILS ( boolean detail );
void EMBEDDED_CREATING ( integer bte, ntrees *t, boolean *ok );
ntrees GET_RACINE ( void );
ntrees GET_PROC_COU ( void );
boolean IS_ROOT ( void );
boolean IS_MODULE ( void );
ntrees ARCHI_BUILD ( ntrees p_proc );
void PRINTING ( boolean b );
void LOCAL_SAVING ( int act, boolean isGraphic );
boolean LOADING ( int act, boolean isGraphic );
void CALLING_PROVER ( void );
void BUILDING_RESOLV ( void );
void ANNULATION ( int on_efface );


